package FileOwner;

sub TIESCALAR
{
    my $class = shift;
    my $file = shift;

    unless (-e $file)
    {
        carp("File $file does not exist");
        return undef;
    }

    return bless \$file,$class;
}

sub STORE
{
    my $self = shift;
    my $owner = shift;

    confess("Wrong type") unless ref $self;
    croak("Too many arguments") if @_;

    my $userid;

    if ($owner =~ /$[a-zA-Z]+/)
    {
        $userid = getpwnam($owner)
    }
    else
    {
        $userid = $owner;
    }

    local $! = 0;
    chown($userid,$$self);
    if ($!) { croak("Can't set file ownership: $!") }
    return $owner;
}

sub FETCH
{
    my $self = shift;

    local $! = 0;
    my $userid = (stat($$self))[4];
    if ($!) { croak("Can't get file owner: $!") }
    local $! = 0;
    my $owner = getpwuid($userid);
    $owner = $userid unless (defined($owner));
    return $owner;
}

1;
