use Getopt::Std;

my $taskfile   = "tasks.db";
my $taskformat = "A40LL";
my $tasklength = length(pack($taskformat,));
my $ref=0;

getopts('drc');

open(D,"<$taskfile") || die "Couldn't open the task file, $!\n";

while(read(D,$_,$tasklength))
{
    ($title,$reqdate,$compdate) = unpack($taskformat,$_);
    $lref{$ref} = $title;
    $lref{$ref} = "$reqdate" if ($opt_r);
    $lref{$ref} = "$compdate" if ($opt_c);
    $ltitle{$ref} = $title;
    $lreqdate{$ref} = $reqdate;
    $lcompdate{$ref} = $compdate;
    $ref++;
}

close(D);

printf("%-40s  %-10s  %-10s\n","Title","Req. Date","Comp. Date");

foreach $key (sort_values(\%lref))
{
    $lreqdate{$key} =~ s#(....)(..)(..)#$3/$2/$1#;
    if ($lcompdate{$key}>0)
    {
        next if ($opt_d);
        $lcompdate{$key} =~ s#(....)(..)(..)#$3/$2/$1#;
    }
    else
    {
        $lcompdate{$key}="";
    }
    printf("%-40s  %10s  
%10s\n",$ltitle{$key},$lreqdate{$key},$lcompdate{$key});
}

sub sort_values
{
    my $lref = shift;

    if ($opt_r || $opt_c)
    {
        sort {$lref{$a} <=> $lref{$b}} keys %$lref;
    }
    else
    {
        sort {$lref{$a} cmp $lref{$b}} keys %$lref;
    }
}
