use Fcntl;

my ($taskfile) = "tasks.db";
my ($taskformat) = "A40LL";
my $tasklength = length(pack($taskformat,));

die "Usage: modtask.pl title completed-date\n" if (@ARGV<2);

open(D,"+<$taskfile") || die "Couldn't open the task file, $!\n";

while(read(D,$_,$tasklength))
{
    ($title,$reqdate,$compdate) = unpack($taskformat,$_);
    last if (($title eq $ARGV[0]) && ($compdate eq 0));
    $lastseek=tell(D);
}

if ($lastseek >= (-s $taskfile))
{
    die "Couldn't find the task specified\n";
}

($mday,$mon,$year) = split '/',$ARGV[-1];
$compdate = ($year*10000)+($mon*100)+$mday;

seek(D,$lastseek,SEEK_SET);

print D pack($taskformat,$title,$reqdate,$compdate);

close(D) || die "Couldn't close the database\n";
