#!/usr/local/bin/perl5 -w 

use NDBM_File; 
use Fcntl;

my ($dbfile,%db,$i,@fieldnames,@fields,$key,$n);

die "Usage:\n$0 source\n" if (@ARGV<1);

$dbfile = $ARGV [0];

open(D,"<$dbfile") || die "Can't open $dbfile, $!";

(tie %db, NDBM_File, $dbfile, O_RDWR|O_CREAT|O_EXCL, 0666)
      || die "$0: Error creating $dbfile: $!\n";
$_ = <D>;
chomp;
s/,//;
@fieldnames = split "\t";

$db{fieldlist} = join(",",@fieldnames);

while(<D>)
{
    chomp;
    @fields = split "\t";

    for($n=0;$n<=@fields;$n++)
    {
        if (defined($fields[$n]))
        {
             $key = $fieldnames[$n] . "-$i";
             $db{$key} = $fields[$n];
        }
    }
    $i++;
}

$db{seqid} = $i;
close(D) || die "$0: Couldn't close source, $!\n";
untie %db || die "$0: Couldn't close db, $!\n";
    
print "Read $i records\n";
