#!/usr/local/bin/perl5

use DBI;
use Getopt::Std;

my ($reqdate,$compdate);
my ($mday,$mon,$year,$key);

getopts('drc');

my ($table) = "csvtasks";

my($dbh) = DBI->connect("DBI:CSV:");

my ($query) = "SELECT * FROM $table";

$query .= " WHERE compdate = 0" if ($opt_d);

if ($opt_r)
{
    $query .= " ORDER BY reqdate";
}
elsif ($opt_c && !($opt_d))
{
    $query .= " ORDER BY compdate";
}
else
{
    $query .= " ORDER BY title";
}

my ($sth) = $dbh->prepare($query) 
           || die "prepare: " . $dbh->errstr();

$sth->execute() || die "execute: " . $dbh->errstr();

printf("%-40s  %-10s  %-10s\n","Title","Req. Date","Comp. Date");

while ($row = $sth->fetchrow_hashref)
{
    $row->{'reqdate'} =~ m/(....)(..)(..)/;
    $reqdate = "$3/$2/$1";

    if ($row->{'compdate'}>0)
    {
       $lcompdate{$key} =~ m/(....)(..)(..)/;
       $compdate = "$3/$2/$1";
    }
    else
    {
       $compdate="";
    }
    printf("%-40s  %10s  %10s\n",$row->{'title'},
                                 $reqdate,$compdate);
}
