#!/usr/local/bin/perl5

use Net::SMTP;
use Net::DNS;

while (@ARGV)
{
    my $email = shift;
    my ($user, $host) = split '@', $email;
    my $res = new Net::DNS::Resolver;
    my @mx = mx($res, $host);
    
    if (@mx) 
    {
        print "Expansions for $email\n";
        foreach my $rr (@mx) 
        {
            my ($mxhost) = $rr->exchange;
            print "Checking $mxhost\n";
            my $smtp = Net::SMTP->new($mxhost);
            unless($smtp)
            {
                warn "Couldn't open connection to $host";
                next;
            }
            my $realrecipient = $smtp->expand($email);
            print "$realrecipient\n" if $realrecipient;
            $smtp->quit();
        }
        print "\n";
    }
    else
    {
        warn "Couldn't find any MX hosts for $host\n";
    }
}
