#!/usr/local/bin/perl -w

use GDBM_File;
use Fcntl;
use strict;

$| = 1;

my @unknowns = ('Eh?', 'What?', 'Pardon?', "Watcha talkin 'bout man?",
                'Er...?', "I'm not sure I understand you.");

tie my %respdb, 'GDBM_File', 'respdb', O_RDWR|O_CREAT, 0666
    or die "Can't open responsee: $!";

print ">> ";

while(<STDIN>)
{
    chomp;
    parse_query();
    print ">> ";
}

sub parse_query
{
    if (my ($key, $value) = m/(\S+)\s+is\s+(.*)/)

    {
        $respdb{lc($key)} = $value;
        print "Gotcha!\n";
    }
    else
    {
        if (exists($respdb{lc($_)}))
        {
            print "$respdb{lc($_)}\n";
        }
        else
        {
            print $unknowns[int(rand(@unknowns))],"\n";
        }
    }
}
